%define	snapshot		20120415
%define	name			libm4ri
%define major			0
%define	libm4ri			%mklibname m4ri %{major}
%define	libm4ri_devel		%mklibname m4ri -d

Name:		%{name}
Group:		Sciences/Mathematics
License:	GPL
Summary:	M4RI is a library for fast arithmetic with dense matrices over F2
Version:	0.%{snapshot}
Release:	3
URL:		http://m4ri.sagemath.org
Source:		http://m4ri.sagemath.org/downloads/m4ri-%{snapshot}.tar.gz

# This patch will not be sent upstream, as it is Fedora-specific.
# Permanently disable SSE3 and SSSE3 detection.  Without this patch, the
# config file tends to be regenerated at inconvenient times.
Patch0:         m4ri-no-sse3.patch

BuildRequires:  doxygen
BuildRequires:	gomp-devel
BuildRequires:  png-devel
BuildRequires:  texlive

%description
M4RI is a library for fast arithmetic with dense matrices over F2.
It was started by Gregory Bard, is maintained by Martin Albrecht.
Several people contributed to it (see below). The name M4RI comes
from the first implemented algorithm: The "Method of the Four Russians"
inversion algorithm published by Gregory Bard. This algorithm in turn
is named after the "Method of the Four Russians" multiplication algorithm
which is probably better referred to as Kronrod's method. M4RI is used by
the Sage mathematics software and the PolyBoRi library. M4RI is available
under the General Public License Version 2 or later (GPLv2+).

%package	-n %{libm4ri}
Group:		System/Libraries
Summary:	M4RI runtime library
Provides:	m4ri = %{version}-%{release}
Provides:	%{name} = %{version}-%{release}

%description	-n %{libm4ri}
M4RI is a library for fast arithmetic with dense matrices over F2.
It was started by Gregory Bard, is maintained by Martin Albrecht.
Several people contributed to it (see below). The name M4RI comes
from the first implemented algorithm: The "Method of the Four Russians"
inversion algorithm published by Gregory Bard. This algorithm in turn
is named after the "Method of the Four Russians" multiplication algorithm
which is probably better referred to as Kronrod's method. M4RI is used by
the Sage mathematics software and the PolyBoRi library. M4RI is available
under the General Public License Version 2 or later (GPLv2+).

%package	-n %{libm4ri_devel}
Group:		Development/C
Summary:	M4RI development files
Provides:	m4ri-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libm4ri} = %{version}-%{release}

%description	-n %{libm4ri_devel}
M4RI is a library for fast arithmetic with dense matrices over F2.
M4RI is used by the Sage mathematics software and the PolyBoRi library.

%prep
%setup -q -n m4ri-%{snapshot}
%patch0 -p0

# Remove an unnecessary direct library dependency from the pkgconfig file
sed -i -e "s/ -lm//" m4ri.pc.in

# Fix library dependencies
sed -i -e "s/-lm \$(LIBPNG_LIBADD)/-lgomp \$(LIBPNG_LIBADD)/" Makefile.in

# Die, rpath, die!
sed -e "s|\(hardcode_libdir_flag_spec=\)'.*|\1|" \
    -e "s|\(runpath_var=\)LD_RUN_PATH|\1|" \
    -i configure 

# Fix a couple of broken doxygen commands
sed -i -e "s/\\\\output/\\\\return/" -e "s/\\\\seealso/\\\\see/" src/misc.h

%build
%ifarch %ix86
# Build an SSE2-enabled version, 
%configure --disable-static --enable-openmp CFLAGS="$RPM_OPT_FLAGS -march=pentium4" \
  LDFLAGS="$RPM_LD_FLAGS -Wl,--as-needed"
sed -e 's/^#undef HAVE_MMX/#define HAVE_MMX/' \
    -e 's/^#undef HAVE_SSE$/#define HAVE_SSE/' \
    -e 's/^#undef HAVE_SSE2/#define HAVE_SSE2/' \
    -i src/config.h
sed -e 's/^\(#define __M4RI_HAVE_SSE2[[:blank:]]*\)0/\11/' \
    -e 's/^\(#define __M4RI_SIMD_CFLAGS[[:blank:]]*\).*/\1" -mmmx -msse -msse2"/' \
    -i src/m4ri_config.h
sed -i 's/^SIMD_CFLAGS =.*/SIMD_CFLAGS = -mmmx -msse -msse2/' Makefile
%else
%configure --disable-static --enable-openmp LDFLAGS="$RPM_LD_FLAGS -Wl,--as-needed"
%endif

%make

%ifarch %ix86
# Build an SSE2-disabled version
cp -a .libs .libs.sse2
make clean
rm -fr .deps
%configure --disable-static --enable-openmp --disable-sse2 \
  LDFLAGS="$RPM_LD_FLAGS -Wl,--as-needed"
%make
%endif

# Build documentation
cd src
doxygen

%install
%makeinstall_std
%ifarch %ix86
mkdir -p %{buildroot}%{_libdir}/sse2
mv %{buildroot}%{_libdir}/libm4ri-*.so %{buildroot}%{_libdir}/sse2
mv .libs .libs.nosse2
mv .libs.sse2 .libs
%makeinstall_std
%endif

%check
make check LD_LIBRARY_PATH=`pwd`/.libs

%files		-n %{libm4ri}
%doc COPYING README
%{_libdir}/libm4ri-*.so
%ifarch %ix86
%{_libdir}/sse2/libm4ri-*.so
%endif

%files		-n %{libm4ri_devel}
%doc doc/html
%{_includedir}/m4ri
%{_libdir}/libm4ri.so
%{_libdir}/pkgconfig/m4ri.pc


%changelog
* Tue Aug 14 2012 Paulo Andrade <pcpa@mandriva.com.br> 0.20120415-3
+ Revision: 814820
- Bump release and rebuild.
- Bump release and rebuild.

* Mon Aug 13 2012 Paulo Andrade <pcpa@mandriva.com.br> 0.20120415-1
+ Revision: 814620
- Update to release matching http://pkgs.fedoraproject.org/cgit/m4ri.git

* Sat Nov 05 2011 Paulo Andrade <pcpa@mandriva.com.br> 0.20111004-1
+ Revision: 718066
- Update to snapshot 20111004 required by sagemath 4.7.2

* Tue Mar 08 2011 Paulo Andrade <pcpa@mandriva.com.br> 0.20100701.p1-1
+ Revision: 642761
- Add patchlevel to version and rebuild

* Tue Sep 21 2010 Paulo Andrade <pcpa@mandriva.com.br> 0.20100701-1mdv2011.0
+ Revision: 580438
- Update to new snapshot 20100701.

* Wed Jul 14 2010 Paulo Andrade <pcpa@mandriva.com.br> 0.20100221-1mdv2011.0
+ Revision: 552961
- Update to snapshot 20100221
- Drop libm4ri-static-devel package

* Fri Jan 22 2010 Paulo Andrade <pcpa@mandriva.com.br> 0.20091120-2mdv2010.1
+ Revision: 495125
+ rebuild (emptylog)

* Mon Jan 04 2010 Paulo Andrade <pcpa@mandriva.com.br> 0.20091120-1mdv2010.1
+ Revision: 486296
- Update to 20091120 snapshot (required by sagemath 4.3)

* Thu Sep 10 2009 Paulo Andrade <pcpa@mandriva.com.br> 0.20090617-4mdv2010.0
+ Revision: 437262
+ rebuild (emptylog)

* Wed Sep 09 2009 Paulo Andrade <pcpa@mandriva.com.br> 0.20090617-3mdv2010.0
+ Revision: 436095
+ rebuild (emptylog)

* Wed Sep 09 2009 Paulo Andrade <pcpa@mandriva.com.br> 0.20090617-2mdv2010.0
+ Revision: 435782
- split package in runtime, devel and static libraries.

* Wed Jul 15 2009 Paulo Andrade <pcpa@mandriva.com.br> 0.20090617-1mdv2010.0
+ Revision: 396456
- Update to newer snapshot, required by sagemath package.

* Tue Apr 07 2009 Paulo Andrade <pcpa@mandriva.com.br> 0.20090105-1mdv2009.1
+ Revision: 365050
- Initial import of libm4ri.
  M4RI is a library for fast arithmetic with dense matrices over F2.
  http://m4ri.sagemath.org
- libm4ri

